//Author : Moreno Petrucci
// June 2013

import ddf.minim.*;
import ddf.minim.signals.*;
import ddf.minim.analysis.*;
import ddf.minim.effects.*;

import processing.serial.*;



Serial myPort;
int valore_aka =0;
int valore_ao = 0;
int punto_aka=0;
int punto_ao=0;


Minim minim;
AudioSample fischio;
AudioSample allarme;
AudioSample voce_aka;
AudioSample voce_ao;
AudioSample voce_chukoku;
PImage img_Tsuki;
PImage img_Start;
PImage img_Scritta;
PImage img_butAjime;
PImage img_butReset;

float inByte = 0;//Non utilizzata
float time_game = 0; //Tempo misurato dall'inizio gioco con pulsante START
float time_aka = 0; 
float time_ao = 0; 
boolean start_game = false;
 
void setup() {
  
  size(900, 600);

  // Gestione Immagini
  img_Tsuki = loadImage("tsuki.png"); 
  img_Start = loadImage("start.png"); 
  img_Scritta = loadImage("kesg.png"); 
  img_butAjime= loadImage("but_ajime.png"); 
  img_butReset= loadImage("but_reset.png"); 
  
  // Gestione Suoni
  minim = new Minim(this);
  fischio = minim.loadSample("fischio_ajime.mp3", 2048);
  allarme = minim.loadSample("no_control2.mp3", 2048);
  voce_aka = minim.loadSample("aka.mp3", 2048);
  voce_ao = minim.loadSample("ao.mp3", 2048);
  voce_chukoku = minim.loadSample("chukoku.mp3", 2048);
  
  // Gestione comunicazione Seriale
  myPort= new Serial(this, Serial.list()[0], 9600);
  myPort.bufferUntil('\n');
   
  background(0); // Sfondo nero
}

void draw() {

     
    background(0);
    
   
    
    // Posizionamento immagini
    image(img_Scritta,130,10,600,100);
    image(img_Tsuki,360,120,150,100);
 
    image(img_butAjime,380,450,100,40);
    image(img_butReset,380,520,100,40);
    
    fill(255,255,255);
    textFont(createFont("Arial", 16));
    text("www.karateterni.it", 360,590);
    
    
  

    fill(255,0,0);
    textFont(createFont("Arial", 36));
    text("AKA :", 50,300);
    textFont(createFont("Liquid Crystal", 136));
    text(punto_aka, 200,300);
    rect(50, 310, int(valore_aka) * 5, 55);
    
    textFont(createFont("Arial", 24));
    text("FORCE: ", 50,390);
    text(valore_aka, 150,390);
    
    
    fill(0,0,255);
    textFont(createFont("Arial", 36));
    text("AO :", 550,300);
    textFont(createFont("Liquid Crystal", 136));
    text(punto_ao, 700,300);
    rect(550, 310, int(valore_ao) * 5, 55);

    textFont(createFont("Arial", 24));
    text("FORCE: ", 550,390);
    text(valore_ao, 650,390);
    //text(time_game/10, 700,420);
    
    if (start_game == true) {
    
        time_game += 0.20;
        
       if (valore_aka > 20 && valore_aka < 100 ) { 
    
         punto_aka +=1;
         myPort.write('r'); // Punto AKA - red
         voce_aka.trigger();
         start_game = false;
       }
       if (valore_ao > 20 && valore_ao < 100 ) { 
         //time_ao = time_game;
         punto_ao +=1;
         myPort.write('b'); // Punto AO - blue
         voce_ao.trigger();
         start_game = false;
       }
   
       if (time_aka > 0 && time_ao > 0) {
         if (time_aka ==time_ao) {
           punto_aka +=1; // PARITA'
           punto_ao +=1;
         }
         if (time_aka > time_ao) {
           punto_ao +=1; // Vince BLU
         }
         if (time_aka < time_ao) {
           punto_aka +=1; // Vince ROSSO
         }
      }
      
    }

}

void mouseReleased() {

 if (overRect(390,450,100,40)) {
      fischio.trigger();
      
      if (start_game == false) {
       start_game=true;
       myPort.write('g');
      }

     
  }
  
    // Pulsante RESET
   if (overRect(380,520,100,40)) {
       punto_aka = 0; 
       punto_ao = 0;  
  }

}



void serialEvent(Serial port) {

   String inString = myPort.readStringUntil('\n');
   int[] valori = int(splitTokens(inString,","));

   valore_aka=abs(int(map(int(valori[1]),310,900,1,100)));

   valore_ao=abs(int(map(int(valori[0]),320,900,1,100)));
   time_ao=valori[2];
   time_aka=valori[3];
   
   if (int(valore_aka)>=100 || int(valore_ao)>=100) {
      allarme.trigger();
      myDelay(1000);
      voce_chukoku.trigger();
      if (int(valore_aka)>=100) {
        punto_aka -=1; 
        start_game=false;
      }
      if (int(valore_ao)>=100)  {punto_ao -=1;start_game=false;}
   }
  
 }
 
boolean overRect(int x, int y, int w, int h) {
    if (mouseX >= x && mouseX <= x + w && mouseY >= y && mouseY <= y + h) {
     return true;
    }
   else {
      return false;
   }

}

boolean overCircle(int x, int y, int diameter) {
  float disX = x - mouseX;
  float disY = y - mouseY;
  if(sqrt(sq(disX) + sq(disY)) < diameter/2 ) {
    return true;
  } else {
    return false;
  }
}

void myDelay(int ms)
{
   try
  {    
    Thread.sleep(ms);
  }
  catch(Exception e){}
}

